--[[	Cooldown Watch
	by SDPhantom
	https://www.wowinterface.com/forums/member.php?u=34145
	https://www.curseforge.com/members/sdphantomgamer/projects	]]
--------------------------------------------------------------------------

local Alpha=(WOW_PROJECT_ID==WOW_PROJECT_MAINLINE and 0.875 or 0.625);
local CDText={};
local function OnUpdate(self)
	local ptr=CDText[self]; if ptr then--	Table can contain false if no FontString found
		local now,start,duration=GetTime(),self:GetCooldownTimes();
		start,duration=start/1000,duration/1000;--	Start and Duration are in milliseconds

--		Calculate needed values
		local elapsed=now-start;
		local remain=math.max(0,duration-elapsed);

--		Colorize text
		if elapsed<0 then		ptr:SetTextColor(1,0,0,Alpha);--	Red if negative elapsed
		elseif remain>=3600 then	ptr:SetTextColor(1,0.5,0,Alpha);--	Orange hours
		elseif remain>=60 then		ptr:SetTextColor(1,1,0,Alpha);--	Yellow minutes
		else				ptr:SetTextColor(1,1,1,Alpha);--	White seconds
		end
	end
end

local function HookCooldown(frame)
	if CDText[frame]==nil then--	Table can contain false if no FontString found
		frame:SetHideCountdownNumbers(frame:IsPaused());--	SetHide to false means show

		local txt=frame:GetRegions();
		if txt and txt:GetObjectType()=="FontString" then--	Sanity Check
--			Reposition/Resize
			txt:ClearAllPoints();
			txt:SetPoint("TOP");
			txt:SetFontObject("NumberFontNormalSmall");

--			Color Manager
			frame:HookScript("OnUpdate",OnUpdate);
		end
		CDText[frame]=txt or false;--	Cast nil to false so we don't run on same frame again
	end
end

--------------------------
--[[	Metatable Hooks	]]
--------------------------
local CDMeta=getmetatable(CreateFrame("Cooldown")).__index;

hooksecurefunc(CDMeta,"SetCooldown",HookCooldown);
hooksecurefunc(CDMeta,"SetCooldownDuration",HookCooldown);
hooksecurefunc(CDMeta,"SetCooldownUNIX",HookCooldown);

hooksecurefunc(CDMeta,"Pause",function(self) return self:SetHideCountdownNumbers(true); end);
hooksecurefunc(CDMeta,"Resume",function(self) return self:SetHideCountdownNumbers(false); end);
